class BatCounter {
  // Declare variables
  int posX, posY;
  int batCount;
  PImage bat;
  Table data;

  // Initialize variables
  BatCounter(int posX, int posY) {
    this.posX = posX;
    this.posY = posY;
    bat = loadImage("bat.png");
    readCount();
    loadtable();
  }

  // Display the batcounter
  void display() {
    colorMode(RGB);
    textSize(35);
    fill(#043D52);
    noStroke();
    rectMode(CENTER);
    rect(posX-60, posY-5, 80, 40);
    fill(255);
    text(batCount, posX-20-textWidth(str(batCount)), posY-5);
    rectMode(CORNERS);
    image(bat, posX+40, posY, 80, 40);
  }

  // Increase the number of bat sightings by one, also store the date and time of the sighting and add one to the batCount, also write this to a file.
  void increaseCounter() {
    batCount++;
    writeCount();
    storeBatDetection();
  }

  // Read the last known number of bat sightings from the file
  void readCount() {
    String[] textFile;
    textFile = loadStrings("BatCounter.txt");
    batCount = int(textFile[0]);
  }

  // Write the number of bat sightings to the file
  void writeCount() {
    String[] batCnt = new String[1];
    batCnt[0] = str(batCount);
    saveStrings("BatCounter.txt", batCnt);
  }

  // Add a new row to a table to store the date and time of the bat sighting.
  void storeBatDetection() {
    TableRow newRow = data.addRow();
    newRow.setInt("Year", year());
    newRow.setInt("Month", month());
    newRow.setInt("Day", day());
    newRow.setInt("Hour", hour());
    newRow.setInt("Minute", minute());
    newRow.setInt("Second", second());
  }

  // Load the table of bat sightings from the csv file 
  void loadtable() {
    data = loadTable("BatData.csv");
    data.setColumnTitle(0, "Year");
    data.setColumnTitle(1, "Month");
    data.setColumnTitle(2, "Day");
    data.setColumnTitle(3, "Hour");
    data.setColumnTitle(4, "Minute");
    data.setColumnTitle(5, "Second");
  }

  // Save the table of bat sightings to the csv file 
  void savetable() {
    saveTable(data, "BatData.csv");
  }
}
